(function(g){
try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG;

	var _upload_url = 'http://211.113.46.201/partner/faceImgUpJson.jsp?svckey=anfacemlang';			// DEV SERVER
	var _detect_url = 'http://mdev.pudding.kr/pud/find.json?svckey=anfacemlang&fileUrl=';			// DEV SERVER
	var _whois_url = 'http://mdev.pudding.kr/pud/whois.json?svckey=anfacemlang&';					// DEV SERVER

	var _upload_url = 'http://pudfaceup.paran.com/partner/faceImgUpJson.jsp?svckey=anfacemlang';	// REAL SERVER
	var _detect_url = 'http://m.pudding.kr/pud/find.json?svckey=anfacemlang&fileUrl=';			// REAL SERVER
	var _whois_url = 'http://m.pudding.kr/pud/whois.json?svckey=anfacemlang&';					// REAL SERVER

	
	var _successCallback;
	var _errorCallback;
	var _opts = {};
	
	
	function findFace(scb, ecb, opts){
		_successCallback = scb;
		_errorCallback = ecb;
		
		_opts = opts;
		_step1_upload(opts.sourceImage, scb, ecb);
	}

	
	function _step1_upload(filePath, scb, ecb){
		if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>> STEP1 UPLOAD (앤진 내장하면 없어질 단계) <<<<<<<<<<<<<<<<<<<<'); }
	    function upload_cb(result) {
	        //result = JSON.parse(result.data);
	    	//console.log(result);

	        //if(_DEBUG) { console.log('pudding upload cb: result=' + JSON.stringify(result)); }
	        if(result.status >= 200 && result.status < 300) {
	            try {
	                var data = JSON.parse(result.data);
	                if(_DEBUG) { console.log('pudding upload cb: data=', data); }
	                
	                _step2_detect(data.response.data.fileUrl, scb, ecb);
	            } catch(e) {
	                ecb(e);
	            }
	            return;
	        }
	        ecb(result);
	    }
	
	    

	    var files = {'upFile': filePath };
	    var headers = app.def.API_HEADERS;
	    
	    if(_DEBUG) { console.log('pudding upload: url=' + _upload_url); }
	    
	    ax.ext.net.curl({
	        method:'POST',
	        url: _upload_url,
	        headers:headers,
	        params:{ },
	        files:files,
	        timeout:2000,
	        success:upload_cb,
	        error:ecb
	    });
	    
	}
	

	function _step2_detect(fileUrl, scb, ecb) {

		if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>> STEP2 FIND RECT (내장 엔진에서 리턴될 예정) <<<<<<<<<<<<<<<<<<<<'); }
	
	    var url = _detect_url + fileUrl + '&lang=' + app.nls.lang + '&v=' + app.def.APP_VERSION;
	    
	    // console.log(url);
	    var headers = app.def.API_HEADERS;

	    function find_cb(result) {
	        req = null;

	        //console.log('pudding find cb: result=' + ax.util.dump(result));
	        if(result.status >= 200 && result.status < 300) {
	            var data = JSON.parse(result.data);
	            console.log('find success', data);
	            
	            xx.page.pageSelectFace.show(function(){
	            	// XXX: live 서버는 data.response.data, dev 서버는 data.data
					app.pageSelectFace.setTargetImage(_opts.sourceImage, data.data || data.response.data);
				});
	            return;
	        }
	        ecb(result);
	    }

	    var opts = {
	            method:'GET',
	            url: url,
	            headers:headers,
	            timeout:2000,
	            success:find_cb,
	            error:ecb
	        };

	    req = ax.ext.net.curl(opts);

	}

	// pageSelectFace 에서 호출됨
	function whois(info, idx, targetFile) {
		_step3_whois(info, idx, targetFile);
	}

	function _step3_whois(info, idx, targetFile) {
		if (_DEBUG) { console.log('>>>>>>>>>>>>>>>>>>> STEP3 WHOIS (Finding) <<<<<<<<<<<<<<<<<<<<',  info, idx, targetFile); }
		
		//console.log('INFO', info);
		var params = {
			'imageId':info.detectionInfo[idx].imageid,
			'faceId':info.detectionInfo[idx].faceid,
			'rect':info.detectionInfo[idx].rect,
			'fileUrl':info.fileUrl,
			'ip': info.ip,
			'v': app.def.APP_VERSION,
			'lang': app.nls.lang
		};
		
		var headers = app.def.API_HEADERS;
		var url = _whois_url + $.param(params);

		if(_DEBUG) { console.log('pudding whois: url=' + url); }
		
		function whois_eb(error) {
			if(_DEBUG) { console.log('pudding whois eb: error=', error); }
			xx.page.back();
		}
			
		function whois_cb(result) {
		
			if(_DEBUG) { console.log('pudding whois cb: result=', result); }
			if(result.status >= 200 && result.status < 300) {
				var data = JSON.parse(result.data);
				if (data && data.response) {
					if(data.response.errCode !== '0x02000') {
						//api call success with error response :S
						//whois_eb(data.response.erroCode);
						//cb(null);
					} else if(data.response.data) {
						
						if(_DEBUG) { console.log('pudding whois cb: result=' , data.response.data); }
						
						xx.page.pageFound.show(function(){
							var html = '<pre>';
								html+= ax.util.dump(data.response.data);
								html+= '</pre>';
							
							
							//console.log(JSON.stringify(data.response.data));
							//alert(html);
							
							var tmpFile = _opts.targetDir + '/' + _opts.targetFile + '1.jpg';
							ax.ext.net.download(data.response.data.cropimg, tmpFile);

							_successCallback(data.response.data);
							
							xx.page.pageFinding.hide();
						});
						
						//cb(data.response.data);
					}
					return;
				}
			}
			whois_eb(result.status);
		}
		
		ax.ext.net.curl({
			method:'GET',
			url: url,
			headers: headers,
			timeout:self.TIMEOUT_API_WHOIS,
			success:whois_cb,
			error:whois_eb
		}); 

	}
			
	function initDevMenu() {
		if (!_DEBUG) { return; }
		
		var scrollOption = {
				wrapperId: 'wrapperMenu',
				onTouchEnd: function(e){
					var target = e.target,
						menu = $(target).html();
					
					console.log(menu);
					$(target).addClass('pressed');
					
					
					setTimeout(function(){
						$(target).removeClass('pressed');
						
						switch(menu){
							case 'File Explorer':
								xx.page.toggleMenu();
								xx.page.pageFileExplorer.show();
								break;
							case 'Delete Facebook Cache':
								xx.fexplorer.deleteFile('documents/facebook.json');
								break;
							case 'Delete Download Cache':
								xx.download.db = {};
								xx.fexplorer.deleteFile('documents/download.json');
								break;
							case '페이스북 더미 셋팅':
								xx.fexplorer.writeFile('documents/facebook.json','{"410512772309480":{"picture":"http://photos-b.ak.fbcdn.net/hphotos-ak-prn1/552375_410512772309480_1631617480_s.jpg","source":"http://a2.sphotos.ak.fbcdn.net/hphotos-ak-prn1/s720x720/552375_410512772309480_1631617480_n.jpg","id":"410512772309480","created_time":"2012-04-04T10:31:38+0000"},"400182546675836":{"picture":"http://photos-b.ak.fbcdn.net/hphotos-ak-ash4/306076_400182546675836_533069797_s.jpg","source":"http://a2.sphotos.ak.fbcdn.net/hphotos-ak-ash4/s720x720/306076_400182546675836_533069797_n.jpg","id":"400182546675836","created_time":"2012-03-20T11:20:23+0000"},"400108280016596":{"picture":"http://photos-g.ak.fbcdn.net/hphotos-ak-ash4/318218_400108280016596_1881922009_s.jpg","source":"http://a7.sphotos.ak.fbcdn.net/hphotos-ak-ash4/318218_400108280016596_1881922009_n.jpg","id":"400108280016596","created_time":"2012-03-20T07:36:26+0000"},"396863173674440":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc7/419682_396863173674440_1996260362_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc7/s720x720/419682_396863173674440_1996260362_n.jpg","id":"396863173674440","created_time":"2012-03-15T15:57:25+0000"},"396737283687029":{"picture":"http://photos-d.ak.fbcdn.net/hphotos-ak-ash4/419442_396737283687029_1354264733_s.jpg","source":"http://a4.sphotos.ak.fbcdn.net/hphotos-ak-ash4/419442_396737283687029_1354264733_n.jpg","id":"396737283687029","created_time":"2012-03-15T11:37:00+0000"},"348745015152923":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-ash4/408011_348745015152923_1781689893_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-ash4/s720x720/408011_348745015152923_1781689893_n.jpg","id":"348745015152923","created_time":"2012-01-13T06:34:26+0000"},"338705809490177":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-ash4/397197_338705809490177_1546377642_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-ash4/s720x720/397197_338705809490177_1546377642_n.jpg","id":"338705809490177","created_time":"2011-12-30T00:35:24+0000"},"337757342918357":{"picture":"http://photos-g.ak.fbcdn.net/hphotos-ak-ash4/402890_337757342918357_1135659163_s.jpg","source":"http://a7.sphotos.ak.fbcdn.net/hphotos-ak-ash4/s720x720/402890_337757342918357_1135659163_n.jpg","id":"337757342918357","created_time":"2011-12-28T16:42:41+0000"},"337042119656546":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-snc7/397403_337042119656546_1923534353_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-snc7/s720x720/397403_337042119656546_1923534353_n.jpg","id":"337042119656546","created_time":"2011-12-27T15:41:45+0000"},"334922279868530":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-snc7/408365_334922279868530_1507263947_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-snc7/s720x720/408365_334922279868530_1507263947_n.jpg","id":"334922279868530","created_time":"2011-12-24T08:24:09+0000"},"331343940226364":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc7/380783_331343940226364_60974806_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc7/380783_331343940226364_60974806_n.jpg","id":"331343940226364","created_time":"2011-12-19T00:43:17+0000"},"330429350317823":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-snc7/390304_330429350317823_562993617_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-snc7/s720x720/390304_330429350317823_562993617_n.jpg","id":"330429350317823","created_time":"2011-12-17T15:15:46+0000"},"298330080194417":{"picture":"http://photos-f.ak.fbcdn.net/hphotos-ak-snc7/320706_298330080194417_836716695_s.jpg","source":"http://a6.sphotos.ak.fbcdn.net/hphotos-ak-snc7/s720x720/320706_298330080194417_836716695_n.jpg","id":"298330080194417","created_time":"2011-10-27T01:20:30+0000"},"251580224869403":{"picture":"http://photos-f.ak.fbcdn.net/hphotos-ak-snc6/263283_251580224869403_4043144_s.jpg","source":"http://a6.sphotos.ak.fbcdn.net/hphotos-ak-snc6/263283_251580224869403_4043144_n.jpg","id":"251580224869403","created_time":"2011-07-27T00:53:17+0000"},"247557961938296":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-ash4/281568_247557961938296_5154959_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-ash4/281568_247557961938296_5154959_n.jpg","id":"247557961938296","created_time":"2011-07-19T00:02:49+0000"},"245613158799443":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-ash4/263646_245613158799443_3340362_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-ash4/263646_245613158799443_3340362_n.jpg","id":"245613158799443","created_time":"2011-07-15T00:53:19+0000"},"238760786151347":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-ash4/267215_238760786151347_2764459_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-ash4/267215_238760786151347_2764459_n.jpg","id":"238760786151347","created_time":"2011-07-01T04:12:20+0000"},"238751582818934":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-snc6/261836_238751582818934_1093848_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-snc6/261836_238751582818934_1093848_n.jpg","id":"238751582818934","created_time":"2011-07-01T03:43:39+0000"},"236432593050833":{"picture":"http://photos-b.ak.fbcdn.net/hphotos-ak-snc6/264965_236432593050833_1925682_s.jpg","source":"http://a2.sphotos.ak.fbcdn.net/hphotos-ak-snc6/264965_236432593050833_1925682_n.jpg","id":"236432593050833","created_time":"2011-06-24T01:36:37+0000"},"227111040649655":{"picture":"http://photos-f.ak.fbcdn.net/hphotos-ak-snc6/251035_227111040649655_4056379_s.jpg","source":"http://a6.sphotos.ak.fbcdn.net/hphotos-ak-snc6/251035_227111040649655_4056379_n.jpg","id":"227111040649655","created_time":"2011-06-16T10:46:06+0000"},"227033130657446":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc6/253791_227033130657446_4740296_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc6/253791_227033130657446_4740296_n.jpg","id":"227033130657446","created_time":"2011-06-16T02:48:23+0000"},"212237068803719":{"picture":"http://photos-g.ak.fbcdn.net/hphotos-ak-ash4/206548_212237068803719_3627515_s.jpg","source":"http://a7.sphotos.ak.fbcdn.net/hphotos-ak-ash4/206548_212237068803719_3627515_n.jpg","id":"212237068803719","created_time":"2011-04-20T13:47:31+0000"},"212236842137075":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc6/221982_212236842137075_5224260_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc6/221982_212236842137075_5224260_n.jpg","id":"212236842137075","created_time":"2011-04-20T13:46:29+0000"},"209970239030402":{"picture":"http://photos-d.ak.fbcdn.net/hphotos-ak-snc6/206546_209970239030402_1999074_s.jpg","source":"http://a4.sphotos.ak.fbcdn.net/hphotos-ak-snc6/206546_209970239030402_1999074_n.jpg","id":"209970239030402","created_time":"2011-04-11T13:28:58+0000"},"209169152443844":{"picture":"http://photos-b.ak.fbcdn.net/hphotos-ak-snc6/205564_209169152443844_27548_s.jpg","source":"http://a2.sphotos.ak.fbcdn.net/hphotos-ak-snc6/205564_209169152443844_27548_n.jpg","id":"209169152443844","created_time":"2011-04-08T09:09:36+0000"},"205261119501314":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-snc6/197402_205261119501314_1269769_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-snc6/197402_205261119501314_1269769_n.jpg","id":"205261119501314","created_time":"2011-03-24T04:45:20+0000"},"203356756358417":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-ash4/190039_203356756358417_2078818_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-ash4/190039_203356756358417_2078818_n.jpg","id":"203356756358417","created_time":"2011-03-17T02:56:18+0000"},"201521479875278":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-snc6/190216_201521479875278_4604822_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-snc6/190216_201521479875278_4604822_n.jpg","id":"201521479875278","created_time":"2011-03-10T05:26:25+0000"},"201521183208641":{"picture":"http://photos-g.ak.fbcdn.net/hphotos-ak-snc6/197695_201521183208641_3738960_s.jpg","source":"http://a7.sphotos.ak.fbcdn.net/hphotos-ak-snc6/197695_201521183208641_3738960_n.jpg","id":"201521183208641","created_time":"2011-03-10T05:23:51+0000"},"197420200285406":{"picture":"http://photos-c.ak.fbcdn.net/hphotos-ak-snc6/180822_197420200285406_1383567_s.jpg","source":"http://a3.sphotos.ak.fbcdn.net/hphotos-ak-snc6/180822_197420200285406_1383567_n.jpg","id":"197420200285406","created_time":"2011-02-22T02:06:24+0000"},"197150583645701":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc6/180475_197150583645701_2317127_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc6/180475_197150583645701_2317127_n.jpg","id":"197150583645701","created_time":"2011-02-21T02:02:17+0000"},"196437050383721":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-ash4/183208_196437050383721_611777_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-ash4/183208_196437050383721_611777_n.jpg","id":"196437050383721","created_time":"2011-02-18T07:14:32+0000"},"196227273738032":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-ash3/182420_196227273738032_2772285_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-ash3/182420_196227273738032_2772285_n.jpg","id":"196227273738032","created_time":"2011-02-17T12:01:47+0000"},"193737290653697":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-snc6/167755_193737290653697_3662207_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-snc6/167755_193737290653697_3662207_n.jpg","id":"193737290653697","created_time":"2011-02-08T07:20:23+0000"},"183292035031556":{"picture":"http://photos-c.ak.fbcdn.net/hphotos-ak-ash3/167464_183292035031556_417850_s.jpg","source":"http://a3.sphotos.ak.fbcdn.net/hphotos-ak-ash3/167464_183292035031556_417850_n.jpg","id":"183292035031556","created_time":"2011-01-02T05:21:54+0000"},"182217185139041":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-snc7/163448_182217185139041_816633_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-snc7/163448_182217185139041_816633_n.jpg","id":"182217185139041","created_time":"2010-12-29T03:33:29+0000"},"181907141836712":{"picture":"http://photos-e.ak.fbcdn.net/hphotos-ak-snc6/164752_181907141836712_4519095_s.jpg","source":"http://a5.sphotos.ak.fbcdn.net/hphotos-ak-snc6/164752_181907141836712_4519095_n.jpg","id":"181907141836712","created_time":"2010-12-28T00:49:08+0000"},"181704975190262":{"picture":"http://photos-a.ak.fbcdn.net/hphotos-ak-snc6/68285_181704975190262_7877089_s.jpg","source":"http://a1.sphotos.ak.fbcdn.net/hphotos-ak-snc6/68285_181704975190262_7877089_n.jpg","id":"181704975190262","created_time":"2010-12-27T08:37:37+0000"},"107145052646255":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-prn1/24741_107145052646255_4355343_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-prn1/24741_107145052646255_4355343_n.jpg","id":"107145052646255","created_time":"2010-03-23T03:23:46+0000"},"107139669313460":{"picture":"http://photos-h.ak.fbcdn.net/hphotos-ak-prn1/24741_107139669313460_1675411_s.jpg","source":"http://a8.sphotos.ak.fbcdn.net/hphotos-ak-prn1/24741_107139669313460_1675411_n.jpg","id":"107139669313460","created_time":"2010-03-23T02:53:58+0000"},"107139552646805":{"picture":"http://photos-d.ak.fbcdn.net/hphotos-ak-prn1/24741_107139552646805_4561074_s.jpg","source":"http://a4.sphotos.ak.fbcdn.net/hphotos-ak-prn1/24741_107139552646805_4561074_n.jpg","id":"107139552646805","created_time":"2010-03-23T02:53:23+0000"}}',false,function(o){console.log(o);});
								break;
							case '파일캐시 더미 셋팅':
								xx.fexplorer.writeFile('documents/download.json','{"400182546675836.jpg":{"path":"/appspresso/file/downloads/400182546675836.jpg"},"396863173674440.jpg":{"path":"/appspresso/file/downloads/396863173674440.jpg"},"410512772309480.jpg":{"path":"/appspresso/file/downloads/410512772309480.jpg"},"400108280016596.jpg":{"path":"/appspresso/file/downloads/400108280016596.jpg"},"396737283687029.jpg":{"path":"/appspresso/file/downloads/396737283687029.jpg"},"348745015152923.jpg":{"path":"/appspresso/file/downloads/348745015152923.jpg"},"337042119656546.jpg":{"path":"/appspresso/file/downloads/337042119656546.jpg"},"330429350317823.jpg":{"path":"/appspresso/file/downloads/330429350317823.jpg"},"337757342918357.jpg":{"path":"/appspresso/file/downloads/337757342918357.jpg"},"338705809490177.jpg":{"path":"/appspresso/file/downloads/338705809490177.jpg"},"247557961938296.jpg":{"path":"/appspresso/file/downloads/247557961938296.jpg"},"331343940226364.jpg":{"path":"/appspresso/file/downloads/331343940226364.jpg"},"238751582818934.jpg":{"path":"/appspresso/file/downloads/238751582818934.jpg"},"251580224869403.jpg":{"path":"/appspresso/file/downloads/251580224869403.jpg"},"245613158799443.jpg":{"path":"/appspresso/file/downloads/245613158799443.jpg"},"334922279868530.jpg":{"path":"/appspresso/file/downloads/334922279868530.jpg"},"227111040649655.jpg":{"path":"/appspresso/file/downloads/227111040649655.jpg"},"212236842137075.jpg":{"path":"/appspresso/file/downloads/212236842137075.jpg"},"227033130657446.jpg":{"path":"/appspresso/file/downloads/227033130657446.jpg"},"238760786151347.jpg":{"path":"/appspresso/file/downloads/238760786151347.jpg"},"236432593050833.jpg":{"path":"/appspresso/file/downloads/236432593050833.jpg"},"209970239030402.jpg":{"path":"/appspresso/file/downloads/209970239030402.jpg"},"212237068803719.jpg":{"path":"/appspresso/file/downloads/212237068803719.jpg"},"209169152443844.jpg":{"path":"/appspresso/file/downloads/209169152443844.jpg"},"205261119501314.jpg":{"path":"/appspresso/file/downloads/205261119501314.jpg"},"203356756358417.jpg":{"path":"/appspresso/file/downloads/203356756358417.jpg"},"201521183208641.jpg":{"path":"/appspresso/file/downloads/201521183208641.jpg"},"197420200285406.jpg":{"path":"/appspresso/file/downloads/197420200285406.jpg"},"298330080194417.jpg":{"path":"/appspresso/file/downloads/298330080194417.jpg"},"193737290653697.jpg":{"path":"/appspresso/file/downloads/193737290653697.jpg"},"201521479875278.jpg":{"path":"/appspresso/file/downloads/201521479875278.jpg"},"183292035031556.jpg":{"path":"/appspresso/file/downloads/183292035031556.jpg"},"196437050383721.jpg":{"path":"/appspresso/file/downloads/196437050383721.jpg"},"107145052646255.jpg":{"path":"/appspresso/file/downloads/107145052646255.jpg"},"182217185139041.jpg":{"path":"/appspresso/file/downloads/182217185139041.jpg"},"107139552646805.jpg":{"path":"/appspresso/file/downloads/107139552646805.jpg"},"196227273738032.jpg":{"path":"/appspresso/file/downloads/196227273738032.jpg"},"107139669313460.jpg":{"path":"/appspresso/file/downloads/107139669313460.jpg"},"197150583645701.jpg":{"path":"/appspresso/file/downloads/197150583645701.jpg"},"181704975190262.jpg":{"path":"/appspresso/file/downloads/181704975190262.jpg"},"181907141836712.jpg":{"path":"/appspresso/file/downloads/181907141836712.jpg"}}', false);
							break;
							case 'DEV Gallery':
								xx.page.toggleMenu();
								xx.page.pageDevGallery.show();
							break;
						};
					}, 300);
					
				},
				scrollbarClass: 'noScroll'
			};
		xx.scroll.addScroll(scrollOption);
		
		xx.page.add({
			id: 'pageFileExplorer',
			onPageBeforeLoadForInit: function() {
				xx.fexplorer.init({
						fileListElement: document.getElementById('file_list'),
						filePreviewElement: document.getElementById('file_preview'),
						fileDetailElement: document.getElementById('file_detail'),
						wrapperId: 'wrapperFileExplorer',
						useQuickScroll: true
					});
				xx.fexplorer.getSubList();
			},
			useAdmob: false
		});

		/*
		xx.page.add({
			id: 'pageDevGallery',
			onPageBeforeLoadForInit: function() {
				app.common.addScript('js/page_dev_gallery.js', function(){
					if (app.common.getPreference('_devgallery') !== 'true') {
						app.pageDevGallery.downloadDevImage();
					}
				});
			},
			onPageLoad: function() {
				app.pageDevGallery.loadGallery();
			},
			onPageHide: function() {
				app.pageDevGallery.resetStatus();
			},
			useAdmob: false
		});
		*/


		var callback = function(selectedMenu) {
			if (selectedMenu === 0) {
				xx.page.toggleMenu();
			} else if (selectedMenu === 2) {
				xx.page.pageSetting.show();
			} else if (selectedMenu === 1) {
				xx.page.pageFileExplorer.show();
			} else if (xx.page.history.length > 2) {
				xx.page.back();
			}
		};
		if (_DEBUG) { ax.ext.android.setOnOptionsItemSelected(callback); }
		if (_DEBUG) { ax.ext.android.setOptionsItems(['Menu','Files', 'Options']); }

		
	}
	

	var oDev = {};
	ax.def(oDev)
		.method('findFace', findFace)
		.method('whois', whois)
		.method('initDevMenu', initDevMenu);
		
		
	// .property('photos', function(){ return _photos; })
	// .method('initPage', initPage);

	ax.def(g.app).constant('dev', oDev);


}catch(e){
	console.log('app_dev.js def err ', e.message); 
}
})(window);


// weinre
function wwww(){ 
	(function(e) {
		e.setAttribute("src", "http://althjs.2do.kr:8090/target/target-script-min.js#althjs");
		document.getElementsByTagName("body")[0].appendChild(e);
	})(document.createElement("script"));
}

