/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		_DEBUG = !!g._DEBUG;

	// XXX: iscroll carousel item  넓이 전역변수. iscroll.js에도 이에 따라 수정 됨.
	g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = undefined;

	function _createTemporaryFolderForAndroid() {
		
		var ecb = function(e) {
			if (_DEBUG) { console.log('.NOMEDIA created failed!! ', e.message); }
		};
		xx.fexplorer.createDirectory('removable/pud', function(){
				xx.fexplorer.createDirectory('removable/pud/.nomedia', function() {
					if (_DEBUG) { console.log('removable/pud/.nomedia folder create success'); }
				},ecb);
				xx.fexplorer.createDirectory('documents/.nomedia', function() {
					if (_DEBUG) { console.log('documents/.nomedia folder create success'); }
				},ecb);
				xx.fexplorer.createDirectory('downloads/.nomedia', function() {
					if (_DEBUG) { console.log('downloads/.nomedia folder create success'); }
				},ecb);
				xx.fexplorer.createDirectory('images/.nomedia', function() {
					if (_DEBUG) { console.log('images/.nomedia folder create success'); }
				},ecb);
				
				xx.fexplorer.createDirectory('removable/axFileTemporary', function() {
					if (_DEBUG) { console.log('images/axFileTemporary folder create success'); }
					
					xx.fexplorer.createDirectory('removable/axFileTemporary/.nomedia', function() {
						if (_DEBUG) { console.log('images/axFileTemporary/.nomedia folder create success'); }
					}, ecb);
				},ecb);

				xx.fexplorer.createDirectory('removable/PuddingFace', function() {
					if (_DEBUG) { console.log('removable/PuddingFace folder create success'); }
				}, ecb);
				
			},ecb);
	}

	function initKPNS() {
		// KPNS 푸시알림 관련
		//setTimeout(function(){
			var kpnsLang = app.common.getPreference('kpnsLang'),
				kpnsToken = app.common.getPreference('kpnsToken'),
				kpnsOldGroup = app.common.getPreference('kpnsOldGroup'),
				langApp = app.nls.langApp,
				group,
				groupPrefix;
			// console.log('initKPNS',kpnsLang, kpnsToken, kpnsOldGroup, langApp);

			var unregisterOldGroup = function(group) {
				if (kpnsOldGroup !== '2.0') {
					var oldGroup = '';
					if (xx.page.platform === 'android') {
						oldGroup = 'a' + group;
					} else {
						oldGroup = 'i' + group;
					}

					g.kpnsPlugin.groupUnregister(function(tf){
						if (_DEBUG) { console.log('kpns oldGroup unregister', oldGroup, tf); }
						app.common.setPreference('kpnsOldGroup', '2.0');
					}, oldGroup);
				}
			};

			if (kpnsLang === '' || kpnsToken === '') {
				g.kpnsPlugin.register(function(dt){
					group = dt.substring(dt.length-1,dt.length);
					groupPrefix = group;
                    app.common.groupPrefix = groupPrefix;
					if (xx.page.platform === 'android') {
						group = 'pud3_a' + group + '_' + langApp;
					} else {
						group = 'pud3_i' + group + '_' + langApp;
					}
					if (_DEBUG) { console.log('kpns token', dt,' group', group); }
					g.kpnsPlugin.groupRegister(function(tf){
						app.common.setPreference('kpnsLang', langApp);
						if (_DEBUG) { console.log('kpns group register', group, tf); }
						setTimeout(function(){
							app.common.setPreference('kpnsToken', dt);
							unregisterOldGroup(groupPrefix);
						}, 500);

					},group);
				});
			} else if (kpnsLang !== langApp) {

				group = kpnsToken.substring(kpnsToken.length-1,kpnsToken.length);
				groupPrefix = group;
                app.common.groupPrefix = groupPrefix;
				if (xx.page.platform === 'android') {
					group = 'pud3_a' + group + '_' + langApp;
				} else {
					group = 'pud3_i' + group + '_' + langApp;
				}
				g.kpnsPlugin.groupRegister(function(tf){
					app.common.setPreference('kpnsLang', langApp);
					if (_DEBUG) { console.log('kpns group register', group, tf); }

					group = kpnsToken.substring(kpnsToken.length-1,kpnsToken.length);
					if (xx.page.platform === 'android') {
						group = 'pud3_a' + group + '_' + kpnsLang;
					} else {
						group = 'pud3_i' + group + '_' + kpnsLang;
					}
					g.kpnsPlugin.groupUnregister(function(tf){
						if (_DEBUG) { console.log('kpns group unregister', group, tf); }
					}, group);

					unregisterOldGroup(groupPrefix);
				},group);

			} else {
				groupPrefix = kpnsToken.substring(kpnsToken.length-1,kpnsToken.length);
                app.common.groupPrefix = groupPrefix;
				unregisterOldGroup(groupPrefix);
			}


		//}, 2000);
	}

	function init() {

		// if (_DEBUG) { g.wwww(); }
	
		if (xx.page.platform === 'android' ) { ax.util.setConfig('ajaxRetry', 10); }

		if (xx.page.model === 'SHW-M110S' || xx.page.model === 'SHW-M130L' || xx.page.model === 'SHW-M130K' || xx.page.model === 'i_u')  {
			$('body').addClass('nofx');
			app.common.setPreference('animation', 'false');
		} else if (app.common.getPreference('animation') === 'false') {
			$('body').addClass('nofx');
		}
		
		// 최초 한번 초기화 필요
		var pageOption = {
			menuId: 'pageMenu',	// optional
			mainPageId: 'pageMain',	// required
			onPageLoad: function(){	// global onPageLoad event
				try{
					app.common.trackPageview(this.id);
					
					var info = this.info;
					if (typeof info.useAdmob !== 'undefined') {
						if (info.useAdmob === false) {
							app.common.hideAdmob();
							return;
						}
					}

					if ($('#layer_gobattle').length === 0) {
						if (app.common.isAdmobShown) {
							app.common.refreshAdmob();
						} else {
							if (info.useAdmob !== false) {
								app.common.showAdmob();
							}
						}
					}

                    setTimeout(function(){
                        app.pageMain.eventAnimationCheck();
                    }, 500);
					
					if (xx.page.platform === 'android') {
						$('.close').unbind().bind('touchstart', function(){console.log('xxx');});
						$('.back').unbind().bind('touchstart', function(){console.log('xxx');});
						$('.home').unbind().bind('touchstart', function(){console.log('xxx');});
						$('.share').unbind().bind('touchstart', function(){console.log('xxx');});
					}
				}catch(e){
					if (_DEBUG) { console.log('global onPageLoad err' + e.message); }
				}
			},
			animationType: 'fade', //app.common.getPreference('animationType'),
			lang: app.nls.langApp
		};
		
		xx.page.init(pageOption);
	
		// add page
		xx.page.add({
			id: 'pageMain',
			type: 'main',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageLoad: function() {
				ax.ext.ui.isWebView = false;
				if (xx.scroll.wrapperMain) {
					g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = app.pageMain.carouselItemWidth;
					xx.scroll.wrapperMain.refresh();
					app.common.isLoading = false;
				}
			}
		});
		app.pageMain.initPage();
	
		xx.page.add({
			id: 'pageFind',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_find.js' , function(){
					self.info.onPageLoad = function() {
						ax.ext.ui.isWebView = false;
						if(_DEBUG) { console.log('pageFind onPageLoad isWebView : ' + ax.ext.ui.isWebView); }
		                app.pageFind.findMode = 'find';
					};
				});
			},
			onPageBeforeLoad: function(){
                ax.ext.ui.isWebView = false;
                if(_DEBUG) { console.log('pageFind onPageBeforeLoad isWebView : ' + ax.ext.ui.isWebView); }
			},
			useLocale: true
		});


		xx.page.add({
			id: 'pageChallenge',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_find.js', function(){
					self.info.onPageLoad = function() {
						ax.ext.ui.isWebView = false;
                        app.pageFind.findMode = 'challenge';
                        //if (app.common.useKM) { g._kmq.push(['record', 'Challengechoice']); }
					};
				});
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageChallengeResult',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				app.common.addScript('js/page_challenge_result.js', function(){
                    app.pageChallengeResult.checkResult();
				});
			},
            onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = false;
            	app.pageChallengeResult.checkResult();
			},
            onPageLoad: function() {
				ax.ext.ui.isWebView = false;
			},
            onPageHide: function(){
				app.pageChallengeResult.resetStatus();
			},
			useLocale: true
		});

        /*  배틀메인 삭제함 <JPUDINGINSIG-840>
		xx.page.add({
			id: 'pageBattle', 
			onPageBeforeLoadForInit: function(){
				var self = this;
				app.common.addScript('js/app_page_battle.js', function(){
					self.info.onPageLoad = function() {
						g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = app.pageBattle.carouselItemWidth;
						xx.scroll.wrapperBattle.refresh();
						$('#global_loading').removeClass('finding');
					};
				});
			},
			useLocale: true
		});
		*/
		
		xx.page.add({
			id: 'pageBattleSearch', 
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				app.common.addScript('js/page_battle_search.js');
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
				if(_DEBUG) { console.log('checkBattleMode called by onPageBeforeLoad'); }
				app.pageBattleSearch.checkBattleMode();
			},
			onPageLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageHide: function(){
				app.pageBattleSearch.resetStatus();
			},
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageBattleSearchStar', 
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_battle_search_star.js', function(){
					self.info.onPageLoad = function() {
						ax.ext.ui.isWebView = false;
						app.pageBattleSearchStar.getRecommmendStar();
						//app.pageBattleSearchStar.showKeyboard();
						if (xx.scroll.wrapperBattleSearchStar) {
							xx.scroll.wrapperBattleSearchStar.refresh();
						}
					};
				});
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageBeforeHide: function() { 
				app.pageBattleSearchStar.resetStatus();
			},
			useAdmob: false,
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageBattleSearchStarGallery', 
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_battle_search_star_gallery.js', function(){
					self.info.onPageLoad = function(){
						ax.ext.ui.isWebView = false;
						app.pageBattleSearchStar.hideKeyboard();
						app.pageBattleSearchStarGallery.loadGallery(app.pageBattleSearchStar.star);
					};	
				});
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageHide: function(){
				$('#wrapperBattleSearchStarGallery ul').html('');
				app.common.isLoading = false;
			},
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageMy',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_my.js', function(){
					self.info.onPageLoad = function(){
						ax.ext.ui.isWebView = false;
						app.pageMy.showScroll();
					};	
				});
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageHide: function() {
				app.pageMy.resetStatus();	
			},
			useLocale: true
		});

		xx.page.add({
			id: 'pageEmpty',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = true;
			},
			onPageBeforeHide: function() {
				try{
					ax.ext.ui.removeWebView();
				} catch(e) {}
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = true;
			},
			onPageLoad: function(){
				//ax.ext.ui.isWebView = true;
			},
			type: 'none',
			useAdmob: true
		});
		
		xx.page.add({
			id: 'pageShare',
			onPageBeforeLoadForInit: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageBeforeHide: function() {
				ax.ext.ui.removeTextView();
				
				if (xx.page.history[xx.page.history.length-1] === 'pageFound') {
					app.share.captureScreenAfter();
				}
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageLoad : function(){
				ax.ext.ui.isWebView = false;
			},
			type: 'none',
			useAdmob: false
		});
		
		xx.page.add({
			id: 'pageSetting', 
			onPageBeforeLoadForInit: function(){
				var self = this;
				app.common.addScript('js/page_setting.js', function(){
					self.info.onPageLoad = function(){
						app.pageSetting.updateUI();
					};
				});
			},
			onPageBeforeLoad:function(){
				ax.ext.ui.isWebView = false;
			},
			onPageBeforeHide: function(){
				app.common.removeWebView();
			},
			type: 'vertical',
			useAdmob: false,
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageSettingCountry',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = false;
				var scrollOption = {
						'wrapperId': 'wrapperSettingCountry',
						scrollbarClass: 'noScroll',
						bounce: false,
						onTouchEnd: app.pageSetting.onCountryTouchEnd
					};
				xx.scroll.addScroll(scrollOption);
			},
			onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = false;
			},
			onPageLoad: function() {
				ax.ext.ui.isWebView = false;
				app.pageSetting.updateStarCategoryUI(app.common.getPreference('starCategory'));
			},
			useAdmob: false,
			useLocale: true
		});
	
		xx.page.add({
			id: 'pageFinding',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = false;
				app.common.addScript('js/page_finding.js');
			},
			onPageBeforeLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageLoad: function(){
				ax.ext.ui.isWebView = false;
			},
			onPageHide: function() {
				$('#global_loading').removeClass('finding');
			},
			type: 'none'
		});
		
		xx.page.add({
			id: 'pageFound',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_found.js', function(){
					self.info.onPageLoad = function(){	
						ax.ext.ui.isWebView = false;
						app.common.isLoading = false;
						if (xx.scroll.wrapperFound) {
							g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = xx.page.wrapperWidth;
							xx.scroll.wrapperFound.refresh();
						}
					};
					app.pageFound.checkResult();
				});
			},
			onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = false;
				app.pageFound.checkResult();
			},
			onPageHide: function() {
				app.pageFound.resetStatus();
			},
			useLocale: true
		});
		
		
		xx.page.add({
			id: 'pageSelectFace',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = false;
				var self = this;
				app.common.addScript('js/page_select.js', function(){
					app.pageSelectFace.setTargetImage();
					self.info.onPageLoad = function(){
						ax.ext.ui.isWebView = false;
						app.common.isLoading = false;
						//app.pageSelectFace.setTargetImage();
					};
				});
			},
			onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = false;
				app.pageSelectFace.setTargetImage();
			},
			onPageHide: function() {
				app.pageSelectFace.removeRect();
			},
			useAdmob: false,
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageFacebookGallery',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = true;
				//if(_DEBUG) { console.log('pageFacebookGallery onPageBeforeLoadInit isWebView : ' + ax.ext.ui.isWebView); }
				app.common.addScript('js/page_facebook.js');
			},
			onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = true;
				//if(_DEBUG) { console.log('pageFacebookGallery onPageBeforeLoad isWebView : ' + ax.ext.ui.isWebView); }
			},
			onPageLoad: function() {
				//if(_DEBUG) { console.log('pageFacebookGallery onPageLoad isWebView : ' + ax.ext.ui.isWebView); }
				$('#global_loading').removeClass('finding');
				app.pageFacebookGallery.checkStatus();
			},
			onPageHide: function() {
				app.common.isLoading = false;
				//if(_DEBUG) { console.log('pageFacebookGallery onPageBeHide isWebView : ' + ax.ext.ui.isWebView); }
			},
			onPageBeforeHide: function() {
				//if(_DEBUG) { console.log('pageFacebookGallery onPageBeforeHide isWebView : ' + ax.ext.ui.isWebView); }
				try{
                    ax.ext.ui.removeWebView();
                } catch(e) {
                    if (_DEBUG) { console.log('pageFacebookGallery onPageBeforeHide err', e.message); }
                }
			},
			useAdmob: false,
			type: 'vertical',
			useLocale: true
		});
		
		xx.page.add({
			id: 'pageBattleResult',
			onPageBeforeLoadForInit: function() {
				ax.ext.ui.isWebView = false;
				app.common.addScript('js/page_battle_result.js', function(){
					app.pageBattleResult.checkResult();
				});
			},
			onPageBeforeLoad: function() {
				ax.ext.ui.isWebView = false;
				app.pageBattleResult.checkResult();
			},
			onPageLoad: function() {
				ax.ext.ui.isWebView = false;
			},
			onPageHide: function() {
				app.pageBattleResult.resetResult();
			},
			useLocale: true
		});
		
		//xx.page.pageBattle.show();
		
		if (xx.page.platform === 'android') {
			_createTemporaryFolderForAndroid();
		}
		
		app.button.startButton();	// button 처리 시작
		
		//console.log(ax.util.dump(app.common.getPreference()));

		setTimeout(function(){
			twitter.load_prefs();
			facebook.load_prefs();
		}, 300);
		
		
		// 메모리 정리
		delete app.intro;
		delete app.start;
		delete app.init;

		app.pageMain.destroyIntro();
		
		if (xx.page.platform !== 'android') {
			setTimeout(function() {
				ax.ext.ui.showStatusBar();

                if ($('#layer_gobattle').length === 0 && !app.common.isFortuneLayer) {
                    setTimeout(function(){
                        app.common.showAdmob();
                    }, 1000);
                }
			}, 1000);
		}
		
		//if (app.nls.lang === 'ko') {
		$('#global_loading .box').html(app.nls.get('common_loading'));
		//}
		
		
		if (xx.page.platform === 'android') {

			g.com.kth.usagelog.init(function(){
				if(_DEBUG) { console.log('com.kth.usagelog success'); }
			}, function(e){
				if(_DEBUG) { console.log('com.kth.usagelog err', e.message); }
			}, app.def.KTH_USAGE_KEY);

			setTimeout(function(){
				g.com.kth.usagelog.fireUsageLog(app.def.KTH_USAGE_EVENT, app.def.APP_VERSION);

				if (xx.page.model === 'SHW-M110S' || xx.page.model === 'SHW-M130L' || xx.page.model === 'SHW-M130K')  {
					$('body').addClass('nofx');
					app.common.setPreference('animation', 'false');
				}
			}, 1000);
		}
        
        
		
		//var _kms = function(u){
		//	setTimeout(function(){
		//		var d = document, f = d.getElementsByTagName('script')[0],
		//		s = d.createElement('script');
		//		s.type = 'text/javascript'; s.async = true; s.src = u;
		//		f.parentNode.insertBefore(s, f);
		//	}, 1);
		//};
		//_kms('//i.kissmetrics.com/i.js');
		//_kms('//doug1izaerwt3.cloudfront.net/' + g._kmk + '.1.js');
		
		//var _kmq = window._kmq;
		//var kmqFirstInit = function() {
		//	if (_DEBUG) {console.log('kmqFirstInit() called'); }
			//_kmq.push(['identify', app.common.getPreference('imei')]);
			//_kmq.push(['record', 'First visited', {
			//		'OS':xx.page.platform, 
			//		'OS Version': xx.page.os, 
			//		'App Version': app.def.APP_VERSION,
			//		'Language': app.nls.lang,
			//		'Model': xx.page.model
			//		}]);
		//};


        //if (app.common.useKM) {
        //    if (app.common.getPreference('imei')) {
        //        _kmq.push(['identify', app.common.getPreference('imei')]);
        //    } else {
        //        if (xx.page.platform === 'android') {
        //            deviceapis.devicestatus.getPropertyValue(
        //                    function (value) { app.common.setPreference('imei', value); kmqFirstInit(); },
        //                    function () { app.common.setPreference('imei', new Date().getTime()); kmqFirstInit(); },
        //                    { aspect: "Device", property : "imei"});
        //        } else {
        //            app.common.setPreference('imei', new Date().getTime());
        //            kmqFirstInit();
        //        }
        //    }
        //}
		
		app.nls.update('#pageShare');


        //xx.page.pageChallengeResult.show();
		//initKPNS();
	}


	function start(){
		
		if (app.common.isNetworkError === true) { return; }
		
		//if (g.localStorage.getItem('useSplash') === 'false' || app.common.loadStatus.page) {
			init();
		//} else {
		//	app.common.addScript('js/page_intro.js', function(){
		//		if (app.common.isNetworkError === true) { return; }
		//		app.intro();
		//	});
		//}
	}


	ax.def(g.app)
		.method('start', start)
        .method('initKPNS', initKPNS)
		.method('init', init);
	
// }catch(e) {
	// console.log('app_main.js def err:',e.message);
// }
}(window));


// iOS/Android onRestoreState event
ax.event.onRestoreState = function(){
	"use strict";

	var app = window.app,
        xx = window.xx;
	if (app.common.inappBackground) {
		setTimeout(function(){
			app.common.inappBackground = app.common.inappBackground - 1;

			if (app.common.inappBackground < 0) {
				app.common.inappBackground = 0;
			}
		}, 1000);
		
	} else {
		
		app.common.isLoading = false;
		setTimeout(function() {
			try {
			    if (xx.page.platform === 'android') {
					window.com.kth.usagelog.fireUsageLog(app.def.KTH_USAGE_EVENT, app.def.APP_VERSION);
					window.kpnsPlugin.cancelAll();
				}
				app.api.appNotice();
				app.pageMain.resetStatus();
			} catch(e) {
				console.log(e.message);
			}
		}, 100);
	}

};

