/*jslint browser:true, confusion:true, debug:true, devel:true, nomen:true, plusplus:true, vars:true */
(function(g){
	"use strict";
// try{
	var ax = g.ax,	// require('ax');
		xx = g.xx,
		app = g.app,
		pageID = 'pageMain',
		oPage = {},
		_DEBUG = !!g._DEBUG;
	
	app.common.isNewMainBanner = false;
		
	var _carouselItemWidth;
	var _settingIdx;	// N표시 판별용. 
	
	var _isEventBallStarted = false,
        _eventUrl,
        _eventBallTimer;

    var balls = document.getElementById('pageMain').querySelectorAll('.header .event img'),
        _ballCurrent = 0;
    
    var groupName;

	var telco = '';
	deviceapis.devicestatus.getPropertyValue(
		function (value) {
			value = value.toUpperCase();
			if (/(SKT)/i.test(value)) {
				telco = 'SKT';
			} else if (/(OLLTH|KT)/i.test(value)) {
				telco = 'KT';
			} else if (/(LG)/i.test(value)) {
				telco = 'LGT';
			} else {
				telco = value || 'ETC';
			}
		},
		function () { telco = 'ETC';},
		{ aspect: "CellularNetwork", property : "operatorName"});

    function eventBall(current) {
        var pre;
        if (current >= 4) {
            current = 0;
            pre = 3;
        } else {
            pre = current - 1;
        }
        // console.log(current);
        _isEventBallStarted = true;

//        balls[pre].style.display = 'none';
//        balls[current].style.display = 'block';
		$(balls[pre]).addClass('hide');
		$(balls[current]).removeClass('hide');
        current++;
        _ballCurrent = current;
        _eventBallTimer = setTimeout(function(){

            if (!xx.page.currentPage() || xx.page.currentPage() === 'pageMain') {
                eventBall(current);
            } else {
                _isEventBallStarted = false;
                if (_eventBallTimer) { g.clearTimeout(_eventBallTimer); }
                _eventBallTimer = undefined;
                setTimeout(function() {
					$('#pageMain .header .event img').addClass('hide');
				}, 500);
            }

        }, 300);
    }

	function _animateEventBall() {
		if (_isEventBallStarted === true) { 
			$('#pageMain .header .event').removeClass('hide');
			//$('#pageMain .header .event').animate(/*{top:-10},*/1300);
			//$('.nls_en #pageMain .header .event').animate({top:-10},1300);
			return;
		}
		
		setTimeout(function(){
			//$('#pageMain .header .event').animate(/*{bottom:-10},*/1300, function(){ eventBall(1); });
			$('#pageMain .header .event').removeClass('hide').after(function() { _eventBallTimer = eventBall(1); });
			//$('.nls_en #pageMain .header .event').animate({bottom:-10},1300, function(){ eventBall(1); });
		}, 1500);
		
	}

    function eventAnimationCheck() {
        if (xx.page.currentPage() === 'pageMain') {
            if (_eventUrl && _isEventBallStarted === false) {
				$('#pageMain .header .event img').addClass('hide');
                eventBall(_ballCurrent);
            }
        }
    }

	function _showMainAD(link, bizName) {
		xx.page.pageEmpty.querySelector('.header h2').innerHTML = app.nls.get('main_ad_headline');
		xx.page.pageEmpty.show();
		app.common.addWebView(link);

        //if (bizName && app.common.useKM) {
        //    g._kmq.push(['record', 'MainAD ' + bizName]);
        //}
	}
	
	function _initMainCarousel(html) {
		var wrapper = document.getElementById('wrapperMain');


		if (typeof app.common.groupPrefix !== 'undefined' && xx.page.platform === 'android') {
			var group = parseInt(app.common.groupPrefix, 10),
				tml = '',
				langApp;

			if (group > 4) {
				langApp = app.nls.langApp;

				/* AB테스트 종료 */
//				tml+='<div data-role="button" title="btnBattle">';
//				tml+='   <img id="main_btn_frame3" class="type1 o1" src="locales/' + langApp + '/image/main_frame03.png" alt="닮은꼴 배틀" /><div class="imgfix">&nbsp;</div>';
//				tml+='   <div class="tit t1"></div>';
//				tml+='   <img id="main_btn_frame3_desc" class="battle-msg  msg-left" src="locales/' + langApp + '/image/main_battle_msg2.png" alt="누가 더 연예인을 닮았을까?" />';
//				tml+='</div>';
//				tml+='<div data-role="button" title="btnFind">';
//				tml+='   <img id="main_btn_frame4" class="type1 o2" src="locales/' + langApp + '/image/main_frame04.png" alt="닮은꼴 연예인 찾기" /><div class="imgfix">&nbsp;</div>';
//				tml+='    <div class="tit t2"></div>';
//				tml+='</div>';
//
//				$('#wrapperMain li').html(tml);

				groupName = 'A';
				app.common.trackEvent('AB테스트', 'A그룹방문');
			} else {
				groupName = 'B';
				app.common.trackEvent('AB테스트', 'B그룹방문');
			}
		} else {
			groupName = 'C';
			app.common.trackEvent('AB테스트', 'C그룹방문');
			if (_DEBUG) { console.log('app.common.groupPrefix is undefined'); }
		}

		$('#wrapperMain li:last-child').after(html);


		var bb = wrapper.querySelectorAll('li'),
			bigAd = $(wrapper).find('li.big_Ad'),
			len = bb.length,
            len2 = bigAd.length,
			screenWidth = window.innerWidth,
			liWidth = screenWidth / 2,
			itemWidth = screenWidth * 265 / 320,
			liLeft = itemWidth / 2,
			hideItem = '';

        if(bigAd) {
            wrapper.querySelector('.scroller').style.cssText = 'width:' + (liLeft*(len+len2)) + 'px';//큰 광고가 있을 때 ul width
        } else {
           wrapper.querySelector('.scroller').style.cssText = 'width:' + (liLeft*(len)) + 'px';//큰 광고가 없을 때 ul width
        }

        var i = 0,
            gap = 0;

        for (i=0; i<len; i++) {
            //console.log ('XXX', $(bb[i])[0].className);
            if ($(bb[i]).hasClass('big_Ad')) {
                bb[i].style.cssText = 'width:' + screenWidth + 'px; left: ' + (liLeft*i+gap) + 'px; ' + hideItem;
                gap += itemWidth/2;
            } else {
                bb[i].style.cssText = 'width:' + liWidth + 'px; left: ' + (liLeft*i+gap) + 'px; ' + hideItem;
            }
        }

        bb[0].style.display = 'block';

		var onTouchEnd = function(e){
			var target = e.target,
				i = 5;
			
		
			while(i--) {
				if (target.tagName === 'BODY') { return; }
				
                if(target.getAttribute('data-role') === 'button') {
					i = 10; 
					break;
				}
				target = target.parentNode;
			}
			
			
			if(target.title){

				if (xx.page.history.length > 1) { return; }	//XXX: 더블탭 방지
				
				$(target).addClass('pressed');
				
				setTimeout(function(){
					$(target).removeClass('pressed');
					
					if(target.title === 'btnFind') {
						xx.page.pageFind.show();
                    } else if (target.title === 'btnChallenge') {
                        app.common.recommendStarMode = 'challenge';
                        xx.page.pageBattleSearchStar.show();
                        //xx.page.pageBattleSearchStar.show(function() {
                        //    if (app.common.useKM) { g._kmq.push(['record', 'Challenge']); }
                        //});
					} else if (target.title === 'btnBattle') {
						app.common.trackEvent('AB테스트', '닮은꼴배틀_' + groupName);
						if (_DEBUG) { console.log('AB테스트 닮은꼴배틀_' + groupName); }

                        app.common.recommendStarMode = 'battle';
                        xx.page.pageBattleSearchStar.show();
                        //xx.page.pageBattleSearchStar.show(function(){
                            //if (app.common.useKM) {
                            //    g._kmq.push(['record', '닮은꼴배틀_연예인선택(new main)', {'type': groupName}]);
                            //}
                        //});
//						xx.page.pageBattle.show(function(){
//                            if (app.common.useKM) {
//                                g._kmq.push(['record', '닮은꼴배틀_메인', {'type': groupName}]);
//                            }
//                        });
					} else if (target.title === 'btnMainAD') {
						var adLink = $(target).attr('link'); 
						if (adLink) {

							if (adLink.indexOf('?') > 0) {
								adLink = adLink  + '&telco=' + telco;
							} else {
								adLink = adLink  + '?telco=' + telco;
							}

							//app.common.trackEvent('메인', '메인광고', $(target).attr('adType'));
							app.common.trackEvent('메인', '메인광고클릭', $('#mainBigBiz').attr('bizName'));
							_showMainAD(adLink, $(target).attr('bizName'));
						}
					}
				},150);
			}
		};
		
		g.ISCROLL_HORIZENTAL_WRAPPER_WIDTH = itemWidth;
		_carouselItemWidth = itemWidth;


        // XXX: 3.1.0 캐로셀 자유 스크롤 되면서 통계수집 중단
		if($('#mainBigBiz').length > 0){
			var checkAdImpression = function(e) {
				if(app.common.isNewMainBanner){
					if(window.innerWidth * 80 / 100 <= Math.abs($('#wrapperMain .scroller').position().left)){
						app.common.isNewMainBanner = false;
						app.common.trackEvent('메인', '메인광고노출', $('#mainBigBiz').attr('bizName'));
					}
				}
				//alert(scrollLeft);
				//app.common.trackEvent('메인', '메인광고노출', $('#mainBigBiz').attr('bizName'));
				/*
				setTimeout(function() {
					var currPageX = xx.scroll.wrapperMain.currPageX;
					if (currPageX > 0) {
						var bizName = $($($('#wrapperMain li')[currPageX]).find('div')[0]).attr('bizName');
	
						app.common.trackEvent('메인', '메인광고노출', bizName);
					}
				}, 10);
				*/
			};
	
			var scrollOption = {
					'wrapperId': 'wrapperMain',
					scrollbarClass: 'noScroll',
					hScrollbar: false,
					snap: true, //false,
					momentum: false, //true,
					bounce: true,
					useTransform: true,
					onTouchEnd: onTouchEnd,
					onScrollEnd: checkAdImpression
				};
				
			// if (html) {
			xx.scroll.addScroll(scrollOption);
	        // }
	
			setTimeout(function() {
				wrapper.style.display = 'block';
				if (bb[1]) { bb[1].style.display = 'block'; }
	            xx.scroll.wrapperMain.scrollTo(0,0);
			}, 300);
		}
	}

	function destroyIntro() {

		$('#pageMain').css('display','').after(function(){
			setTimeout(function(){
				$('#pageIntro').css({opacity: 0}).after(function(){
					setTimeout(function(){ $('#pageIntro').remove(); }, 3000);
					try {
						xx.scroll.wrapperMain.refresh();

                        xx.scroll.wrapperMain.scrollTo(0,0);
					} catch(e) {
						if (_DEBUG) { console.log('destroyIntro err', e.message); }
					}
				});
			}, 10);
		});
	}

	function _checkMainAD(ad) {
		try{
		
			var i, 
				len, 
				item,
				html = '';
				
			for (i=0, len=ad.length; i<len; i++) {
				item = ad[i];
				
				//console.log(ax.util.dump(item));
				if (!item.bizName) {
                    item.bizName = item.bizLinkUrl;
                }
				if (item.bizType === 'MS') {	// 작은 광고
					html += '<li><div data-role="button" adType="MS" title="btnMainAD" link="' + item.bizLinkUrl + '" bizName="' + item.bizName + '"><img class="type1 o1" src="' + item.bizImgUrl + '"/><img class="type1 o1 pressbg" src="image/main_bg_adpress1.png"></div></li>';
                    /*
					if (typeof ad[i+1] !== 'undefined' && ad[i+1].bizType === 'MS') {
						i++;
						item = ad[i];
	
						html += '<div data-role="button" adType="MS" title="btnMainAD" link="' + item.bizLinkUrl + '" bizName="' + item.bizName + '"><img class="type1 o2" src="' + item.bizImgUrl + '"/><img class="type1 o2 pressbg" src="image/main_bg_adpress1.png"></li></div>';
					} else {
						html += '<div><img class="type1 o2" style="visibility:hidden;"/></li></div>';
					}
					*/
				} else if (item.bizType === 'MB') {	// 큰 광고
					html += '<li class="big_Ad"><div id="mainBigBiz" data-role="button" adType="MB" title="btnMainAD" link="' + item.bizLinkUrl + '" bizName="' + item.bizName + '"><img class="type2" src="' + item.bizImgUrl + '"/><img class="type2 pressbg" src="image/main_bg_adpress2.png"></li></div>';
				}
	
				
			}
			app.common.isNewMainBanner = true;
			_initMainCarousel(html);
			
		} catch(e) {
			if (_DEBUG) { console.log('XXX _checkMainAD err', e.message); }
		}
	}
	
	function _checkEvent() {	
		app.initKPNS();
		var errback = function(e) {
			if (_DEBUG) { console.log('API_MAIN_INFO (EVENT) ERR', e.message); }
			
			app.common.isNetworkError = true;
			// XXX: 메인이벤트  API  호출 실패시에도 우선 네트워크 오류로 봄. 
			var msg = app.nls.get('svc_network_error');//$NLS$
			ax.ext.ui.alert(function() {
				try {
					ax.ext.ios.finish();
				} catch(e) { 
					ax.ext.android.finish();
				}
			}, msg, {'positive': app.nls.get('common_ok')});
			//_checkMainAD([]);
		};

		var callback = function(result) {
			try {
				
				if (typeof app.start === 'function') { 
					app.start();	//XXX 메인이벤트 이후 인트로 시작??  
				}
				
				if (_DEBUG) { console.log('API_MAIN_INFO (EVENT) SUCCESS', result); }
				
				var data = app.api.validateResponse(result);
				if (_DEBUG) { console.debug('MAIN INFO DATA:', ax.util.dump(data)); }
				
				if (data === null) { return; }

				if (data.useKM === 'Y') {
					app.common.useKM = true;
				}
				// app.common.useKM = true; // DEBUG

				if (data.setting === 'Y') {
					_settingIdx = data.settingIdx;
					
					if (data.settingIdx !== app.common.getPreference('settingIdx')) {
						$('#pageMain .new').removeClass('hide');
					}
				}
				
				if (data.eventUrl && data.eventUrl !== 'null') {
					_eventUrl = data.eventUrl;
					_ballCurrent = 0;
					$('#pageMain .event').unbind().bind('touchstart', function(){
						setTimeout(function(){
							if (xx.page.loadingPage || xx.page.history.length > 1) {
								if (_DEBUG) { console.log('페이지 이동 중... 더블탭 (메인 이벤트볼)'); } 
								return;	//XXX: 더블탭 방지	
							}
							app.common.trackEvent('메인', '자체이벤트');

							var url = data.eventUrl;
							if (url.indexOf('?') > 0) {
								url = url  + '&telco=' + telco;
							} else {
								url = url  + '?telco=' + telco;
							}

							_showMainAD(url);
						},300);
					});
					
					_animateEventBall();
					
				} else {
                    _eventUrl = undefined;
                }

				if (data.bizList) {
					_checkMainAD(data.bizList);
				} else {
                    _initMainCarousel('');
                }
				
				if (data.logoImg) {
					$('#mainTitle').animate({opacity:0}, 400, function(){
						$(this).attr('src', data.logoImg).after(function(){
							$(this).animate({opacity:1}, 1000);
						});
					});
				} else {
                    $('#mainTitle').attr('src','locales/' + app.nls.langApp + '/image/main_title.png');
                }
			} catch(e) {
                alert(e.message);
				errback(e);
			}
		};
		
		if (_DEBUG) { console.log('API_MAIN_INFO (EVENT)', app.def.API_MAIN_INFO); }
		
		ax.ext.net.curl({
			method:'GET',
			url: app.def.API_MAIN_INFO,
			headers: app.def.API_HEADERS,
			timeout: app.def.TIMEOUT_API_DEFAULT,
			success: callback,
			error: errback
		});
	}
	
	function resetStatus() {
		var lis = $('#wrapperMain li'),
			i,
			len = lis.length;
		
		for (i=2; i<len; i++) {
			$(lis[i]).remove();
		}
		
        xx.scroll.wrapperMain.scrollTo(0,0);
		xx.scroll.wrapperMain.destroy();
		$('#wrapperMain .scroller').css({width: _carouselItemWidth});
		delete xx.scroll.wrapperMain;
		
		$('#pageMain .new').addClass('hide');
		//$('#pageMain .header .event').css({top: -200});
		$('#pageMain .header .event').addClass('hide');
		$('#mainTitle').attr('src','locales/' + app.nls.langApp + '/image/main_title.png');

		_checkEvent();
		
	}
	
	function initPage() {
		app.api.appNotice();
		app.nls.update('#pageMain');



		app.common.startGA();

		// XXX: 앱시작시 배틀안내 레이어 정책으로 인해 admob은 app.common 모듈안에서 처리.

		//if (xx.page.platform === 'android') { aniBalloon(); }
	}
	
//	function aniBalloon() {
//		$('.battle-msg').addClass(" play");
//        g.setTimeout(function() {
//			$('.battle-msg').removeClass(" play");
//		}, 2000);
//
//	}
//    g.setInterval(function() {
//			aniBalloon();
//    }, 3000);

	var lang = app.nls.langApp;
	$('#main_btn_frame1').attr('src', 'locales/' + lang + '/image/main_frame01.png');
	//$('#main_btn_frame2').attr('src', 'locales/' + lang + '/image/main_frame02.png');
	$('#main_btn_frame3').attr('src', 'locales/' + lang + '/image/main_frame03.png');
	
	//$('#main_btn_frame3_desc').attr('src', 'locales/' + lang + '/image/main_battle_msg2.png');
	
	$('.main_event_ball1').attr('src', 'locales/' + lang + '/image/main_event1.png');
	$('.main_event_ball2').attr('src', 'locales/' + lang + '/image/main_event2.png');

	function newChallenge() {
		$('.new_menu').toggleClass('on');
	}
	g.setInterval(function() {
		newChallenge();
	}, 300);

	 ax.def(oPage)
		.property('carouselItemWidth', function(){ return _carouselItemWidth; })
		.property('settingIdx', function() { return _settingIdx; })
		.property('telco', function() { return telco; })
		.property('groupName', function() { return groupName; })
		.method('checkEvent', _checkEvent)
		.method('initPage', initPage)
		.method('resetStatus', resetStatus)
		.method('destroyIntro', destroyIntro)
        .method('eventAnimationCheck', eventAnimationCheck);
		

	ax.def(g.app).constant(pageID, oPage);

	//키보드 제어를 위해 기본 높이값 계산
	//app.common.height = window.innerHeight;
	//운세 이벤트 레이어
	//if(xx.page.platform !== 'android'){
		app.common.isFortuneLayer = false;
		if(app.nls.langApp === 'ko'){
			var fortuneLayer = $('.layer_face');
			var showFortuneLayer = function(){
				app.common.isFortuneLayer = true;
				fortuneLayer.removeClass('hide');
				$('.layer_face .close').click(function(){
					app.common.setPreference('closeFortuneLayerTime',new Date().getTime());
					app.common.setPreference('viewFortuneLayerTime','');
					app.common.isFortuneLayer = false;
					fortuneLayer.addClass('hide');
					app.common.showAdmob();
				});
				$('.layer_face .cont').click(function(){
					app.common.setPreference('viewFortuneLayerTime',new Date().getTime());
					app.common.setPreference('closeFortuneLayerTime','');
					app.common.isFortuneLayer = false;
					fortuneLayer.addClass('hide');
					if(xx.page.platform == 'android'){
						ax.ext.ui.open('http://bit.ly/S6fReL');
					} else {
						ax.ext.ui.open('http://api.pudface.pudding.kr/event/html/redirect/apple.html');
					}
					app.common.showAdmob();
				});
			};
		
			var closeFortuneLayerTime = app.common.getPreference('closeFortuneLayerTime');
			var viewFortuneLayerTime = app.common.getPreference('viewFortuneLayerTime');
			if(!closeFortuneLayerTime && !viewFortuneLayerTime){
				showFortuneLayer();
			} else if(closeFortuneLayerTime && new Date().getTime() > parseInt(closeFortuneLayerTime) + 3600 * 24 * 1000) {
				showFortuneLayer();
			} else if(viewFortuneLayerTime &&  new Date().getTime() > parseInt(viewFortuneLayerTime) + 3600 * 24 * 7 * 1000) {
				showFortuneLayer();
			}
		}
	//}
// }catch(e){
	// console.log('page_main.js def err ', e.message); 
// }
}(window));